## mvdsv 0.35

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9.0)

set(CMAKE_VERBOSE_MAKEFILE ON)

# Set project name and languge.
project(mvdsv C)


######################################################################################################

# Set where sources located.
set(DIR_SRC "src")

# Add sources
set(SRC_COMMON
	"${DIR_SRC}/bothtools.c"
	"${DIR_SRC}/build.c"
	"${DIR_SRC}/cmd.c"
	"${DIR_SRC}/cmodel.c"
	"${DIR_SRC}/common.c"
	"${DIR_SRC}/crc.c"
	"${DIR_SRC}/cvar.c"
	"${DIR_SRC}/fs.c"
	"${DIR_SRC}/hash.c"
	"${DIR_SRC}/mathlib.c"
	"${DIR_SRC}/md4.c"
	"${DIR_SRC}/net.c"
	"${DIR_SRC}/net_chan.c"
	"${DIR_SRC}/pmove.c"
	"${DIR_SRC}/pmovetst.c"
	"${DIR_SRC}/pr2_cmds.c"
	"${DIR_SRC}/pr2_edict.c"
	"${DIR_SRC}/pr2_exec.c"
	"${DIR_SRC}/vm.c"
	"${DIR_SRC}/vm_interpreted.c"
	"${DIR_SRC}/vm_x86.c"
	"${DIR_SRC}/pr_cmds.c"
	"${DIR_SRC}/pr_edict.c"
	"${DIR_SRC}/pr_exec.c"
	"${DIR_SRC}/sha1.c"
	"${DIR_SRC}/sha3.c"
	"${DIR_SRC}/sv_ccmds.c"
	"${DIR_SRC}/sv_demo.c"
	"${DIR_SRC}/sv_demo_misc.c"
	"${DIR_SRC}/sv_demo_qtv.c"
	"${DIR_SRC}/sv_ents.c"
	"${DIR_SRC}/sv_init.c"
	"${DIR_SRC}/sv_login.c"
	"${DIR_SRC}/sv_main.c"
	"${DIR_SRC}/sv_master.c"
	"${DIR_SRC}/sv_mod_frags.c"
	"${DIR_SRC}/sv_move.c"
	"${DIR_SRC}/sv_nchan.c"
	"${DIR_SRC}/sv_phys.c"
	"${DIR_SRC}/sv_save.c"
	"${DIR_SRC}/sv_send.c"
	"${DIR_SRC}/sv_user.c"
	"${DIR_SRC}/vfs_os.c"
	"${DIR_SRC}/vfs_pak.c"
	"${DIR_SRC}/world.c"
	"${DIR_SRC}/zone.c"
	"${DIR_SRC}/pcre/get.c"
	"${DIR_SRC}/pcre/pcre.c"
	)

# Check build target, and included sources
if(UNIX)
	list(APPEND SRC_COMMON
	    "${DIR_SRC}/sv_sys_unix.c"
	)
else()
	list(APPEND SRC_COMMON
	    "${DIR_SRC}/sv_sys_win.c"
	    "${DIR_SRC}/sv_windows.c"
	    "${DIR_SRC}/winquake.rc"
	)
endif()


######################################################################################################

# Check for curl, and include sources and libs, if found
find_package(CURL)
if(NOT CURL_FOUND)
	message(STATUS "Curl library not found")
else()
	list(APPEND SRC_COMMON
	    "${DIR_SRC}/central.c"
	)
endif()


######################################################################################################

# Set base compiler flags
set(CFLAGS -Wall)
set(LFLAGS)


######################################################################################################

# Set target
add_executable(${PROJECT_NAME} ${SRC_COMMON})
set_target_properties(${PROJECT_NAME}
	PROPERTIES #PREFIX "" # Strip lib prefix.
	C_VISIBILITY_PRESET hidden # Hide all symbols unless excplicitly marked to export.
	)


######################################################################################################

# Set include directories
target_include_directories(${PROJECT_NAME} PRIVATE ${CURL_INCLUDE_DIRS})


######################################################################################################

# Check build target, and included sources and libs
if(UNIX)
	target_link_libraries(${PROJECT_NAME} m)
	target_link_libraries(${PROJECT_NAME} dl)
else()
	target_link_libraries(${PROJECT_NAME} ws2_32)
	target_link_libraries(${PROJECT_NAME} winmm)
	set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc")
endif()


######################################################################################################

# Set defines for the build
target_compile_definitions(${PROJECT_NAME} PRIVATE SERVERONLY)
target_compile_definitions(${PROJECT_NAME} PRIVATE USE_PR2)

include (TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
	target_compile_definitions(${PROJECT_NAME} __BIG_ENDIAN__Q__)
	message(STATUS "BIG_ENDIAN")
else()
	target_compile_definitions(${PROJECT_NAME} PRIVATE __LITTLE_ENDIAN__Q__)
	message(STATUS "LITTLE_ENDIAN")
endif()

if(CURL_FOUND)
	target_compile_definitions(${PROJECT_NAME} PRIVATE WWW_INTEGRATION)
	target_link_libraries(${PROJECT_NAME} ${CURL_LIBRARIES})
endif()


######################################################################################################

# Assign compiler flags
target_compile_options(${PROJECT_NAME} PRIVATE ${CFLAGS})

target_link_libraries(${PROJECT_NAME} -lpthread)


######################################################################################################

=== debian/changelog ===
mvdsv (0.35-2) unstable; urgency=medium

  * Initial release (Closes: #862954)

 -- Lee Garrett <debian@rocketjump.eu>  Fri, 02 Sep 2022 15:29:00 +0200

=== debian/control ===
Source: mvdsv
Maintainer: Lee Garrett <debian@rocketjump.eu>
Section: games
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libpcre3-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.1.0
Vcs-Browser: https://salsa.debian.org/games-team/mvdsv
Vcs-Git: https://salsa.debian.org/games-team/mvdsv.git
Homepage: https://github.com/QW-Group/mvdsv/

Package: mvdsv
Architecture: any
Depends: ${shlibs:Depends},${misc:Depends},
Recommends: quake-data | game-data-packager
Provides: quakeworld-server
Description: QuakeWorld-compatible dedicated server
 MultiView Demo SerVer (mvdsv) has been the most popular QuakeWorld server in
 the world for the more than a decade because of its ability to record every
 player's point of view in a server side demo and provide many different game
 modes to enjoy QuakeWorld with.
 .
 This package contains no data files. To use it, you will need either the
 commercial Quake 1 data, the shareware data (game-data-packager can be
 helpful), or free game data files such as OpenQuartz.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --buildsystem=cmake

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%mvdsv-$1.tar.gz%" \
  https://github.com/QW-Group/mvdsv/releases \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## mvdsv 1.00

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,24 @@
 
 # Set project name and languge.
 project(mvdsv C)
+
+
+######################################################################################################
+
+# Checkout shared qwprot repository
+find_package(Git QUIET)
+if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
+    option(GIT_SUBMODULE "Check submodules during build" ON)
+    if(GIT_SUBMODULE)
+        message(STATUS "Submodule update")
+        execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive
+                        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+                        RESULT_VARIABLE GIT_SUBMOD_RESULT)
+        if(NOT GIT_SUBMOD_RESULT EQUAL "0")
+            message(FATAL_ERROR "git submodule update --init --recursive failed with ${GIT_SUBMOD_RESULT}, please checkout submodules")
+        endif()
+    endif()
+endif()
 
 
 ######################################################################################################
@@ -57,10 +75,8 @@
 	"${DIR_SRC}/sv_user.c"
 	"${DIR_SRC}/vfs_os.c"
 	"${DIR_SRC}/vfs_pak.c"
-	"${DIR_SRC}/world.c"
+	"${DIR_SRC}/sv_world.c"
 	"${DIR_SRC}/zone.c"
-	"${DIR_SRC}/pcre/get.c"
-	"${DIR_SRC}/pcre/pcre.c"
 	)
 
 # Check build target, and included sources
@@ -89,6 +105,24 @@
 	)
 endif()
 
+######################################################################################################
+ 
+# Check for PCRE. if found, include it; if not found, use bundled PCRE.
+find_library(PCRE_LIBRARIES pcre)
+if(PCRE_LIBRARIES)
+	set(PCRE_FOUND 1)
+	find_path(PCRE_INCLUDE_DIR pcre.h)
+endif(PCRE_LIBRARIES)
+
+if(NOT PCRE_FOUND)
+	message(STATUS "PCRE library not found. Using bundled PCRE instead.")
+	list(APPEND SRC_COMMON
+	    "${DIR_SRC}/pcre/get.c"
+	    "${DIR_SRC}/pcre/pcre.c"
+	)
+else()
+	message(STATUS "Found PCRE: ${PCRE_LIBRARIES}")
+endif()
 
 ######################################################################################################
 
@@ -110,7 +144,9 @@
 ######################################################################################################
 
 # Set include directories
+target_include_directories(${PROJECT_NAME} PRIVATE ${DIR_SRC}/qwprot/src)
 target_include_directories(${PROJECT_NAME} PRIVATE ${CURL_INCLUDE_DIRS})
+target_include_directories(${PROJECT_NAME} PRIVATE ${PCRE_INCLUDE_DIR})
 
 
 ######################################################################################################
@@ -118,7 +154,7 @@
 # Check build target, and included sources and libs
 if(UNIX)
 	target_link_libraries(${PROJECT_NAME} m)
-	target_link_libraries(${PROJECT_NAME} dl)
+	target_link_libraries(${PROJECT_NAME} ${CMAKE_DL_LIBS})
 else()
 	target_link_libraries(${PROJECT_NAME} ws2_32)
 	target_link_libraries(${PROJECT_NAME} winmm)
@@ -131,11 +167,14 @@
 # Set defines for the build
 target_compile_definitions(${PROJECT_NAME} PRIVATE SERVERONLY)
 target_compile_definitions(${PROJECT_NAME} PRIVATE USE_PR2)
+target_compile_definitions(${PROJECT_NAME} PRIVATE MVD_PEXT1_SERVERSIDEWEAPON)
+target_compile_definitions(${PROJECT_NAME} PRIVATE MVD_PEXT1_SERVERSIDEWEAPON2)
+target_compile_definitions(${PROJECT_NAME} PRIVATE FTE_PEXT2_VOICECHAT)
 
 include (TestBigEndian)
 TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
 if(IS_BIG_ENDIAN)
-	target_compile_definitions(${PROJECT_NAME} __BIG_ENDIAN__Q__)
+	target_compile_definitions(${PROJECT_NAME} PRIVATE __BIG_ENDIAN__Q__)
 	message(STATUS "BIG_ENDIAN")
 else()
 	target_compile_definitions(${PROJECT_NAME} PRIVATE __LITTLE_ENDIAN__Q__)
@@ -147,6 +186,10 @@
 	target_link_libraries(${PROJECT_NAME} ${CURL_LIBRARIES})
 endif()
 
+if(PCRE_FOUND)
+	target_link_libraries(${PROJECT_NAME} ${PCRE_LIBRARIES})
+endif()
+
 
 ######################################################################################################

=== debian/changelog ===
mvdsv (1.00-0deepin1) unstable; urgency=medium

  * Update to 1.00

  -- Alphagocc <alphagocc@163.com>  Wed, 18 Dec 2024 00:19:20 +0800

mvdsv (0.35-6) unstable; urgency=high

  * Fix build failure on big endian systems

 -- Lee Garrett <debian@rocketjump.eu>  Sat, 28 Jan 2023 14:50:04 +0100

mvdsv (0.35-5) unstable; urgency=high

  * mvdsv.install: Use wildcard instead of variable.
    This hopefully fixes build failure on i386.

 -- Lee Garrett <debian@rocketjump.eu>  Fri, 27 Jan 2023 16:15:12 +0100

mvdsv (0.35-4) unstable; urgency=high

  * Fix FTBFS on other archs
  * Enable curl support
  * Add man page for mvdsv command
  * Bump Standards-Version (no changes needed)
  * Update watch file

 -- Lee Garrett <debian@rocketjump.eu>  Fri, 27 Jan 2023 13:31:23 +0100

mvdsv (0.35-3) unstable; urgency=high

  * Build only for amd64 for now (Closes: #1021797)

 -- Lee Garrett <debian@rocketjump.eu>  Mon, 02 Jan 2023 20:08:31 +0100

## mvdsv 1.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -82,26 +82,22 @@
 # Check build target, and included sources
 if(UNIX)
 	list(APPEND SRC_COMMON
-	    "${DIR_SRC}/sv_sys_unix.c"
-	)
+		"${DIR_SRC}/sv_sys_unix.c"
+	)
+	# Check for curl, and include sources and libs, if found
+	find_package(CURL)
+	if(NOT CURL_FOUND)
+		message(STATUS "Curl library not found")
+	else()
+		list(APPEND SRC_COMMON
+			"${DIR_SRC}/central.c"
+		)
+	endif()
 else()
 	list(APPEND SRC_COMMON
-	    "${DIR_SRC}/sv_sys_win.c"
-	    "${DIR_SRC}/sv_windows.c"
-	    "${DIR_SRC}/winquake.rc"
-	)
-endif()
-
-
-######################################################################################################
-
-# Check for curl, and include sources and libs, if found
-find_package(CURL)
-if(NOT CURL_FOUND)
-	message(STATUS "Curl library not found")
-else()
-	list(APPEND SRC_COMMON
-	    "${DIR_SRC}/central.c"
+		"${DIR_SRC}/sv_sys_win.c"
+		"${DIR_SRC}/sv_windows.c"
+		"${DIR_SRC}/winquake.rc"
 	)
 endif()
 
@@ -132,9 +128,11 @@
 
 
 ######################################################################################################
-
-# Set target
-add_executable(${PROJECT_NAME} ${SRC_COMMON})
+# Mark the executable as a non-console application
+if(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
+	set(TARGET_TYPE WIN32)
+endif()
+add_executable(${PROJECT_NAME} ${TARGET_TYPE} ${SRC_COMMON})
 set_target_properties(${PROJECT_NAME}
 	PROPERTIES #PREFIX "" # Strip lib prefix.
 	C_VISIBILITY_PRESET hidden # Hide all symbols unless excplicitly marked to export.
@@ -158,7 +156,9 @@
 else()
 	target_link_libraries(${PROJECT_NAME} ws2_32)
 	target_link_libraries(${PROJECT_NAME} winmm)
-	set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc")
+	if(NOT CMAKE_C_COMPILER_ID STREQUAL "MSVC")
+		set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc")
+	endif()
 endif()
 
 
@@ -196,7 +196,9 @@
 # Assign compiler flags
 target_compile_options(${PROJECT_NAME} PRIVATE ${CFLAGS})
 
-target_link_libraries(${PROJECT_NAME} -lpthread)
-
-
-######################################################################################################
+if(NOT CMAKE_C_COMPILER_ID STREQUAL "MSVC")
+	target_link_libraries(${PROJECT_NAME} -lpthread)
+endif()
+
+
+######################################################################################################

=== debian/changelog ===
mvdsv (1.11-1) unstable; urgency=high

  * New upstream version 1.11
  * Add debian/gbp.conf and switch to DEP-14 packaging layout
  * Remove 0001-use-system-pcre3.patch and 0002-fix-big-endian.patch (applied
    upstream)
  * Port to PCRE2 (Closes: #1050187)
  * refresh quilt patches
  * fix build error
  * Bump Standards-Version (no changes needed)

 -- Lee Garrett <debian@rocketjump.eu>  Thu, 10 Apr 2025 13:14:29 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,11 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               libpcre3-dev,
+               libcurl4-openssl-dev,
+               libpcre2-dev,
+               libqwprot-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.6.1.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/games-team/mvdsv
 Vcs-Git: https://salsa.debian.org/games-team/mvdsv.git
 Homepage: https://github.com/QW-Group/mvdsv/

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%" \
https://api.github.com/repos/QW-Group/mvdsv/releases?per_page=100 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@
